package cokr.xit.fims.mngt.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.fims.mngt.Ntc;
import cokr.xit.fims.mngt.NtcQuery;
import cokr.xit.fims.mngt.dao.NtcMapper;
import cokr.xit.foundation.component.AbstractBean;
import cokr.xit.foundation.data.DataObject;

/** 공지사항 Bean
 * @author leebj
 */
@Component("ntcBean")
public class NtcBean extends AbstractBean {

	@Resource(name="ntcMapper")
	private NtcMapper ntcMapper;

	/**지정한 조건에 따라 공지사항 목록을 조회하여 반환한다.
	 * @param req 공지사항 조회 조건
	 * @return 공지사항 목록
	 */
	public List<DataObject> getNtcList(NtcQuery req) {
		if(ifEmpty(req.getOrderBy(), "").equals("")) {
			req.setOrderBy("REG_DT DESC");
		}
		return ntcMapper.selectNtcList(req);
	}

	/**지정한 공지사항ID로 공지사항 객체를 반환한다.
	 * @param ntcId 공지사항 ID
	 * @return 공지사항 객체
	 */
	public DataObject getNtcInfo(String ntcId) {
		return ntcMapper.selectNtcInfo(ntcId);
	}

	/**공지사항 정보를 등록한다.
	 * @param ntc 공지사항
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean create(Ntc ntc) {
		return ntcMapper.insert(ntc);
	}

	/**공지사항 정보를 수정한다.
	 * @param ntc 공지사항
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean update(Ntc ntc) {
		return ntcMapper.update(ntc);
	}

	/**공지사항 정보를 삭제한다.
	 * @param ntc 공지사항
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean remove(Ntc ntc) {
		return ntcMapper.delete(ntc);
	}

}
